ompi/class/ompi_pointer_array.h File Reference.TH "ompi/class/ompi_pointer_array.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/class/ompi_pointer_array.h \- See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'opal/class/opal_object.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef \fBompi_pointer_array_t\fP \fBompi_pointer_array_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (\fBompi_pointer_array_t\fP)"
.br
.RI "\fIClass declaration. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_pointer_array_add\fP (\fBompi_pointer_array_t\fP *array, void *ptr)"
.br
.RI "\fIAdd a pointer to the array (Grow the array, if need be). \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBompi_pointer_array_set_item\fP (\fBompi_pointer_array_t\fP *array, int index, void *value)"
.br
.RI "\fISet the value of an element in array. \fP"
.ti -1c
.RI "static void * \fBompi_pointer_array_get_item\fP (\fBompi_pointer_array_t\fP *table, int index)"
.br
.RI "\fIGet the value of an element in array. \fP"
.ti -1c
.RI "static int \fBompi_pointer_array_get_size\fP (\fBompi_pointer_array_t\fP *array)"
.br
.RI "\fIGet the size of the pointer array. \fP"
.ti -1c
.RI "OMPI_DECLSPEC bool \fBompi_pointer_array_test_and_set_item\fP (\fBompi_pointer_array_t\fP *table, int index, void *value)"
.br
.RI "\fITest whether a certain element is already in use. \fP"
.ti -1c
.RI "static void \fBompi_pointer_array_remove_all\fP (\fBompi_pointer_array_t\fP *array)"
.br
.RI "\fIEmpty the array. \fP"
.in -1c
.SH "Detailed Description"
.PP 
See \fBompi_bitmap.h\fP for an explanation of why there is a split between OMPI and ORTE for this generic class. 

Utility functions to manage fortran <-> c opaque object translation. Note that since MPI defines fortran handles as [signed] int's, we use int everywhere in here where you would normally expect size_t. There's some code that makes sure indices don't go above FORTRAN_HANDLE_MAX (which is min(INT_MAX, fortran INTEGER max)), just to be sure.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int ompi_pointer_array_add (\fBompi_pointer_array_t\fP * table, void * ptr)"
.PP
Add a pointer to the array (Grow the array, if need be). 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP Pointer to \fBompi_pointer_array_t\fP object (IN) 
.br
\fIptr\fP Pointer to be added to table (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Array index where ptr is inserted or OMPI_ERROR if it fails 
.RE
.PP

.SS "static void* ompi_pointer_array_get_item (\fBompi_pointer_array_t\fP * table, int index)\fC [inline, static]\fP"
.PP
Get the value of an element in array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN) 
.br
\fIindex\fP Index of element to be returned (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Error code. NULL indicates an error. 
.RE
.PP

.SS "static int ompi_pointer_array_get_size (\fBompi_pointer_array_t\fP * array)\fC [inline, static]\fP"
.PP
Get the size of the pointer array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
size Size of the array
.RE
.PP
Simple inline function to return the size of the array in order to hide the member field from external users. 
.SS "static void ompi_pointer_array_remove_all (\fBompi_pointer_array_t\fP * array)\fC [inline, static]\fP"
.PP
Empty the array. 
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN) 
.RE
.PP

.SS "OMPI_DECLSPEC int ompi_pointer_array_set_item (\fBompi_pointer_array_t\fP * table, int index, void * value)"
.PP
Set the value of an element in array. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP Pointer to \fBompi_pointer_array_t\fP object (IN) 
.br
\fIptr\fP Pointer to be added to table (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Error code
.RE
.PP
Assumption: NULL element is free element. 
.SS "OMPI_DECLSPEC bool ompi_pointer_array_test_and_set_item (\fBompi_pointer_array_t\fP * table, int index, void * value)"
.PP
Test whether a certain element is already in use. 
.PP
If not yet in use, reserve it.
.PP
\fBParameters:\fP
.RS 4
\fIarray\fP Pointer to array (IN) 
.br
\fIindex\fP Index of element to be tested (IN) 
.br
\fIvalue\fP New value to be set at element index (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
true/false True if element could be reserved False if element could not be reserved (e.g.in use).
.RE
.PP
In contrary to array_set, this function does not allow to overwrite a value, unless the previous value is NULL ( equiv. to free ). 
.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
